Index: trunk/ICeCoffEE/ICeCoffEE/APEMain.m
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/APEMain.m	(revision 152)
+++ trunk/ICeCoffEE/ICeCoffEE/APEMain.m	(revision 167)
@@ -67,5 +67,8 @@
 CFBundleRef ICCF_bundle;
 
-void APEBundleMain(CFBundleRef inBundle)
+// With APE 1.3, if we're in the exclude list, APEBundleMainEarlyLoad doesn't get invoked; don't need to use APETools.  But we need to do our own management to avoid loading in non-GUI appllications.
+Boolean ICCF_shouldLoad;
+
+void APEBundleMainEarlyLoad(CFBundleRef inBundle, CFStringRef inAPEToolsApplicationID)
 {
     ICCF_MigratePrefs();
@@ -77,12 +80,5 @@
     SAFE_RELEASE(icVersionRef);
 
-    // first check if this application is in the exclude list;
-    // if it is, simply return and do not apply any patches.
-    // APETools will help us with that; APE Manager will take care of
-    // exclude list management for us.
-    if (APEToolsIsInExcludeList(kICBundleIdentifier, NULL)) {
-        ICapeprintf("ICeCoffEE APE: not loading as this application is excluded.\n");
-        return;
-    }
+    ICCF_shouldLoad = false;
 
     CPSProcessSerNum psn;
@@ -106,10 +102,21 @@
         return;
 #endif
-    }
-    ICapeprintf("ICeCoffEE APE: got process attributes = 0x%lx\n", info.Attributes);
-    if (info.Attributes & (kCPSBGOnlyAttr | kCPSUIElementAttr | kCPSFullScreenAttr)) {
-        ICapeprintf("ICeCoffEE APE: not loading as this application is background-only\n");
-        return;
-    }
+    } else {
+        ICapeprintf("ICeCoffEE APE: got process attributes = 0x%lx\n", info.Attributes);
+        if (info.Attributes & (kCPSBGOnlyAttr | kCPSUIElementAttr | kCPSFullScreenAttr)) {
+            ICapeprintf("ICeCoffEE APE: not loading as this application is background-only\n");
+            return;
+        }
+    }
+    ICCF_shouldLoad = true;
+}
+
+Boolean ICCF_CFBundleIDMatches(CFStringRef bundleID, CFStringRef test) {
+    return CFStringCompare(bundleID, test, kCFCompareCaseInsensitive) == kCFCompareEqualTo;
+}
+
+void APEBundleMainLateLoad(CFBundleRef inBundle, CFStringRef inAPEToolsApplicationID)
+{
+    if (!ICCF_shouldLoad) return;
 
     ICCF_bundle = CFBundleGetBundleWithIdentifier(kICBundleIdentifier);
@@ -119,9 +126,10 @@
     // XXX handle patching error return from ICCF_PatchMethod
     if (bundleID != NULL) {
-        if (CFStringCompare(bundleID, CFSTR("com.apple.projectbuilder"), kCFCompareCaseInsensitive) == kCFCompareEqualTo) {
+        if (ICCF_CFBundleIDMatches(bundleID, CFSTR("com.apple.projectbuilder")) ||
+            ICCF_CFBundleIDMatches(bundleID, CFSTR("com.apple.xcode"))) {
             ICCF_PatchMethod("PBXTextView", "ICeCoffEEMenuOnly", "ICeCoffEEMenuSuper", "menuForEvent:");
             ICapeprintf("ICeCoffEE APE: loaded in PBXTextView for PB!\n");
             shouldLoadInNSTextView = NO;
-        } else if (CFStringCompare(bundleID, CFSTR("com.apple.terminal"), kCFCompareCaseInsensitive) == kCFCompareEqualTo) {
+        } else if (ICCF_CFBundleIDMatches(bundleID, CFSTR("com.apple.terminal"))) {
             ICCF_PatchMethod("TermSubview", "ICeCoffEEMenuOnly", "ICeCoffEEMenuSuper", "menuForEvent:") &&
             ICCF_PatchMethod("TermSubview", "ICeCoffEETerminal", "ICECoffEETermSubviewSuper", "selectedRange") &&
@@ -132,14 +140,15 @@
             ICCF_PatchMethod("TermSubview", "ICeCoffEETerminal", "ICECoffEETermSubviewSuper", "_optionClickEvent:::") ,
             ICapeprintf("ICeCoffEE APE: loaded in TermSubview for Terminal!\n");
-        } else if (CFStringCompare(bundleID, CFSTR("com.apple.safari"), kCFCompareCaseInsensitive) == kCFCompareEqualTo) {
-#if ICCF_WEBKIT
-            ICCF_PatchMethod("WebHTMLView", "ICeCoffEEWebKit", "ICeCoffEEWebKitSuper", "mouseUp:") &&
-            ICCF_PatchMethod("WebHTMLView", "ICeCoffEEWebKit", "ICeCoffEEWebKitSuper", "mouseDown:") &&
-            ICCF_PatchMethod("WebHTMLView", "ICeCoffEEWebKit", "ICeCoffEEWebKitSuper", "menuForEvent:") , 
-            ICapeprintf("ICeCoffEE APE: loaded in WebHTMLView for Safari!\n");
-#endif
-        }
-    }
-
+        } else if (ICCF_CFBundleIDMatches(bundleID, CFSTR("org.mozilla.navigator"))) {
+            ICCF_PatchMethod("ChildView", "ICeCoffEEMenuOnly", "ICeCoffEEMenuSuper", "menuForEvent:");
+            ICapeprintf("ICeCoffEE APE: loaded in ChildView for Camino\n");
+        }
+    }
+
+    ICCF_PatchMethod("WebHTMLView", "ICeCoffEEWebKit", "ICeCoffEEWebKitSuper", "mouseUp:") &&
+        ICCF_PatchMethod("WebHTMLView", "ICeCoffEEWebKit", "ICeCoffEEWebKitSuper", "mouseDown:") &&
+        ICCF_PatchMethod("WebHTMLView", "ICeCoffEEWebKit", "ICeCoffEEWebKitSuper", "menuForEvent:"),
+        ICapeprintf("ICeCoffEE APE: loaded in WebHTMLView for WebKit/Safari\n");
+    
     if (shouldLoadInNSTextView) {
         ICCF_PatchMethod("NSTextView", "ICeCoffEE", "ICeCoffEESuper", "mouseDown:") &&
Index: trunk/ICeCoffEE/ICeCoffEE/English.lproj/APE Manager plugin.nib/info.nib
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/English.lproj/APE Manager plugin.nib/info.nib	(revision 152)
+++ trunk/ICeCoffEE/ICeCoffEE/English.lproj/APE Manager plugin.nib/info.nib	(revision 167)
@@ -4,7 +4,7 @@
 <dict>
 	<key>IBDocumentLocation</key>
-	<string>355 114 356 240 0 0 1280 832 </string>
+	<string>306 97 356 240 0 0 1152 746 </string>
 	<key>IBFramework Version</key>
-	<string>291.0</string>
+	<string>364.0</string>
 	<key>IBGroupedObjects</key>
 	<dict>
@@ -29,5 +29,5 @@
 	</array>
 	<key>IBSystem Version</key>
-	<string>6L60</string>
+	<string>7W98</string>
 	<key>IBUserGuides</key>
 	<dict>
Index: trunk/ICeCoffEE/ICeCoffEE/Exports.exp
===================================================================
--- trunk/ICeCoffEE/ICeCoffEE/Exports.exp	(revision 152)
+++ trunk/ICeCoffEE/ICeCoffEE/Exports.exp	(revision 167)
@@ -1,2 +1,3 @@
-_APEBundleMain
+_APEBundleMainEarlyLoad
+_APEBundleMainLateLoad
 _APEBundleMessage
